using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace SharpProxyService

{
    public class TraficLoger:SharpProxyPlugin 
    {
        PluginVoidResult DoNothing = new PluginVoidResult();
        string _CWD;
        public static bool WriteTraf = false;
        public override void AfterProxyRequestDisposed(ProxyRequest DisposedRequest)
        {
            
        }
        public override void AfterServerDisconnected(ProxyRequest CurrentRequest)
        {
            
        }
        public override PluginVoidResult BeforeSendDataToClient(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult BeforeSendDataToServer(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            if (WriteTraf)
            {
                //generate filename
                try
                {
                    string FileName = _CWD + "\\Trafic Loger\\" + DateTime.Now.Ticks.ToString() + ".to_server";
                    //write to server
                    FileStream FS = File.Open(FileName , FileMode.Append, FileAccess.Write, FileShare.Read);
                    FS.Write(BYTES, 0, BytesCount);
                    FS.Flush();
                    FS.Close();
                }
                catch { }
            }

            return DoNothing;
        }
        public override void LoadPluginSettings(string CWD)
        {
            _CWD = CWD;
            if (!Directory.Exists(CWD + "\\Trafic Loger")) 
            {
                try
                {
                    Directory.CreateDirectory(CWD + "\\Trafic Loger");
                }
                catch { }
            }
            
        }
        public override PluginVoidResult OnClientConnected(System.Net.Sockets.Socket ClientSocket)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnClientDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            if (WriteTraf) 
            { 
                //generate filename
                try
                {
                    //write from client
                    string FileName = _CWD + "\\Trafic Loger\\" + DateTime.Now.Ticks.ToString() + ".from_client";
                    FileStream FS = File.Open(FileName , FileMode.Append, FileAccess.Write, FileShare.Read);
                    FS.Write(BYTES, 0, BytesCount);
                    FS.Flush();
                    FS.Close();
                }
                catch { }
            }
            return DoNothing;
        }
        public override void OnClientDisconnected(System.Net.Sockets.Socket ClientSocket)
        {
             
        }

        public override PluginVoidResult OnFtpDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnNewProxyRequestBuild(ProxyRequest CurrentProxyRequest)
        {

            return DoNothing;
        }
        public override void OnPlug(List<SharpProxyPlugin> TheAllLoadedPlugins)
        {
            
        }
        public override PluginVoidResult OnProxyRequestDisposing(ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnServerDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            if (WriteTraf)
            {
                //generate filename
                try
                {
                    //if (!CurrentProxyRequest.PluginData.ContainsKey(this.PluginName))
                    //{
                    //    CurrentProxyRequest.PluginData.Add(this.PluginName, _CWD + "\\Trafic Loger\\" + DateTime.Now.Ticks.ToString() + "_");
                    //}
                    string FileName = _CWD + "\\Trafic Loger\\" + DateTime.Now.Ticks.ToString() + ".from_server";
                    //write from server
                    FileStream FS = File.Open(FileName , FileMode.Append, FileAccess.Write, FileShare.Read);
                    FS.Write(BYTES, 0, BytesCount);
                    FS.Flush();
                    FS.Close();
                }
                catch { }
            }

            return DoNothing;
        }
        public override void OnUnPlug(UnplugReason TheReason)
        {
            if (TheForm != null)
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }
            
        }

        public override string PluginName
        {
            get { return "Trafic loger"; }
        }

        public override System.Collections.Hashtable PluginSettings
        {
            get { return null ; }
        }

        public override int PluginVersion
        {
            get { return 1; }
        }
        Trafic_Loger TheForm;
        public override void Show_Setting_For_User_To_Edit(System.Windows.Forms.Form TheMDIParent_Form)
        {
            if (TheForm != null) 
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }
            TheForm = new Trafic_Loger();
            TheForm.MdiParent = TheMDIParent_Form;
            TheForm.Visible = true;
            TheForm.WindowState = System.Windows.Forms.FormWindowState.Maximized;
        }

        public override PluginType TheType
        {
            get { return PluginType.EXTRA_FUNCTIONS; }
        }
    }
}
